Attribute VB_Name = "modBeispiel"
#Const Benchmark = False

Option Explicit

Private Declare Function MessageBoxW Lib "user32.dll" (ByVal hWnd As Long, ByVal lpText As Long, ByVal lpCaption As Long, ByVal uType As Long) As Long
Private Declare Function MessageBoxA Lib "user32.dll" (ByVal hWnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal uType As Long) As Long

Private Const MB_ICONINFORMATION As Long = &H40&
Private Const MB_TASKMODAL As Long = &H2000&


Private Sub Main()

#If Benchmark Then
    Benchmark
#Else
    ZeichenTest
    APITest
    DateiTest
#End If

End Sub


Private Sub ZeichenTest()

Const berschrift As String = "Zeichenersetzung"
Dim Test As String

Test = "Test"
MsgBox Test, vbInformation, berschrift                     'Test

MsgBox Hex$(LCh(Test)), vbInformation, berschrift          'U+0054 = T
LCh(Test) = &H52&                                           'U+0052 = R
MsgBox Test, vbInformation, berschrift                     'Rest

MsgBox Hex$(MCh(Test, 2)), vbInformation, berschrift       'U+0065 = e
MCh(Test, 2) = &H6F&                                        'U+006F = o
MsgBox Test, vbInformation, berschrift                     'Rost

MsgBox Hex$(RCh(Test)), vbInformation, berschrift          'U+0074 = t
RCh(Test) = &H73&                                           'U+0073 = s
MsgBox Test, vbInformation, berschrift                     'Ross

End Sub


Private Sub APITest()

Dim Text As String
Dim berschrift As String

Text = "Hallo!" & vbNewLine & ChrW$(&H3B1&) & ChrW$(&H3B2&) & ChrW$(&H3B3&)     'einige griechische Zeichen
berschrift = "Die MessageBox-API"

MessageBoxW 0, StrPtr(Text), StrPtr(berschrift), MB_ICONINFORMATION Or MB_TASKMODAL
MessageBoxA 0, Text, berschrift, MB_ICONINFORMATION Or MB_TASKMODAL

End Sub


Private Sub DateiTest()

Dim Pfad As String
Dim Datei As CEncodedFile

Pfad = App.Path

If RCh(Pfad) <> &H5C& Then Pfad = Pfad & "\"

Set Datei = New CEncodedFile

With Datei
    .Load Pfad & "Test - ANSI.txt"
    MsgBox .Text, vbInformation, "ANSI-Datei"
    .Load Pfad & "Test - UTF-8.txt"
    MsgBox .Text, vbInformation, "UTF-8-Datei"
    .Load Pfad & "Test - UTF-16 BE.txt"
    MsgBox .Text, vbInformation, "UTF-16 BE-Datei"
    .Load Pfad & "Test - UTF-16 LE.txt"
    MsgBox .Text, vbInformation, "UTF-16 LE-Datei"
    .Load Pfad & "Test - UTF-32 BE.txt"
    MsgBox .Text, vbInformation, "UTF-32 BE-Datei"
    .Load Pfad & "Test - UTF-32 LE.txt"
    MsgBox .Text, vbInformation, "UTF-32 LE-Datei"
End With

Set Datei = Nothing

End Sub

