Attribute VB_Name = "modBenchmark"
Option Explicit

Private Declare Function GetTickCount Lib "kernel32.dll" () As Long

Private Const mDurchgnge As Long = 50
Private Const mWiederholungen As Long = 1000000
Private Const mLnge As Long = 1000

Private mText As String
Private mZeichen As Long
Private mVorher As Long
Private mKrzestes As Long
Private mSumme As Long
Private mAuen As Long
Private mInnen As Long


Public Sub Benchmark()
'Ein Benchmark zum Testen der Unicode-Ersatzfunktionen

Open "Benchmark.txt" For Output As #1

Print #1, "Durchgnge:"; Tab(40); CStr(mDurchgnge)
Print #1, "Wiederholungen:"; Tab(40); CStr(mWiederholungen)
Print #1, "Lnge:"; Tab(40); CStr(mLnge)
Print #1,

TestLeft
TestLCh
TestRight
TestRCh
TestMid
TestMCh

Close #1

End Sub


Private Sub TestLeft()

VorTest "Left$", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = AscW(Left$(mText, 1))
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub TestLCh()

VorTest "LCh", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = LCh(mText)
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

VorTest "LCh", True

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        LCh(mText) = mZeichen
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub TestRight()

VorTest "Right$", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = AscW(Right$(mText, 1))
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub TestRCh()

VorTest "RCh", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = RCh(mText)
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

VorTest "RCh", True

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        RCh(mText) = mZeichen
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub TestMid()

VorTest "Mid$", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = AscW(Mid$(mText, (Rnd * (mLnge - 1)) + 1, 1))
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

VorTest "Mid$", True

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        Mid$(mText, (Rnd * (mLnge - 1)) + 1, 1) = ChrW$(mZeichen)
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub TestMCh()

VorTest "MCh", False

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        mZeichen = MCh(mText, (Rnd * (mLnge - 1)) + 1)
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

VorTest "MCh", True

For mAuen = 1 To mDurchgnge
    VorDurchgang
    For mInnen = 1 To mWiederholungen
        MCh(mText, (Rnd * (mLnge - 1)) + 1) = mZeichen
    Next mInnen
    NachDurchgang
Next mAuen

NachTest

End Sub


Private Sub VorTest(ByRef Funktion As String, ByVal Setzen As Boolean)

Print #1, "Zeichen mit "; Funktion; IIf(Setzen, " setzen", " auslesen")

mKrzestes = &H7FFFFFFF

End Sub


Private Sub NachTest()

Print #1, "Krzester Durchgang:"; Tab(40); CStr(mKrzestes)
Print #1, "Durchschnitt:"; Tab(40); CStr(mSumme / mDurchgnge)
Print #1,

mSumme = 0

End Sub


Private Sub VorDurchgang()

mZeichen = Rnd * &HFFFF&
mText = String$(mLnge, 0)

For mAuen = 1 To mLnge
    MCh(mText, mAuen) = Rnd * &HFFFF&
Next mAuen

mVorher = GetTickCount

End Sub


Private Sub NachDurchgang()

Dim Nachher As Long
Dim Dauer As Long

Nachher = GetTickCount

Dauer = Nachher - mVorher

If Dauer < mKrzestes Then mKrzestes = Dauer

mSumme = mSumme + Dauer

DoEvents

End Sub

